<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripInterfaceResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripInterfaceResult_V5 extends AbstractStructArrayBase
{
    /**
     * The TripInterfaceResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripInterfaceResult_V5[]
     */
    public $TripInterfaceResult_V5;
    /**
     * Constructor method for ArrayOfTripInterfaceResult_V5
     * @uses ArrayOfTripInterfaceResult_V5::setTripInterfaceResult_V5()
     * @param \StructType\TripInterfaceResult_V5[] $tripInterfaceResult_V5
     */
    public function __construct(array $tripInterfaceResult_V5 = array())
    {
        $this
            ->setTripInterfaceResult_V5($tripInterfaceResult_V5);
    }
    /**
     * Get TripInterfaceResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripInterfaceResult_V5[]|null
     */
    public function getTripInterfaceResult_V5()
    {
        return isset($this->TripInterfaceResult_V5) ? $this->TripInterfaceResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripInterfaceResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripInterfaceResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripInterfaceResult_V5ForArrayConstraintsFromSetTripInterfaceResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item instanceof \StructType\TripInterfaceResult_V5) {
                $invalidValues[] = is_object($arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item) ? get_class($arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item), var_export($arrayOfTripInterfaceResult_V5TripInterfaceResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripInterfaceResult_V5 property can only contain items of type \StructType\TripInterfaceResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripInterfaceResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripInterfaceResult_V5[] $tripInterfaceResult_V5
     * @return \ArrayType\ArrayOfTripInterfaceResult_V5
     */
    public function setTripInterfaceResult_V5(array $tripInterfaceResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripInterfaceResult_V5ArrayErrorMessage = self::validateTripInterfaceResult_V5ForArrayConstraintsFromSetTripInterfaceResult_V5($tripInterfaceResult_V5))) {
            throw new \InvalidArgumentException($tripInterfaceResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripInterfaceResult_V5) || (is_array($tripInterfaceResult_V5) && empty($tripInterfaceResult_V5))) {
            unset($this->TripInterfaceResult_V5);
        } else {
            $this->TripInterfaceResult_V5 = $tripInterfaceResult_V5;
        }
        return $this;
    }
    /**
     * Add item to TripInterfaceResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripInterfaceResult_V5 $item
     * @return \ArrayType\ArrayOfTripInterfaceResult_V5
     */
    public function addToTripInterfaceResult_V5(\StructType\TripInterfaceResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripInterfaceResult_V5) {
            throw new \InvalidArgumentException(sprintf('The TripInterfaceResult_V5 property can only contain items of type \StructType\TripInterfaceResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripInterfaceResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripInterfaceResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripInterfaceResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripInterfaceResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripInterfaceResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripInterfaceResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripInterfaceResult_V5
     */
    public function getAttributeName()
    {
        return 'TripInterfaceResult_V5';
    }
}
